<i18n>
{
  "fr": {
    "delete-msg-1": "Suppression",
    "delete-msg-2": "Êtes vous sûr de vouloir supprimer la mission",
    "field-1": "Validité",
    "field-2": "Valide",
    "field-3": "Non valide",
    "field-4": "Départ",
    "field-5": "Destination",
    "field-6": "Mode",
    "field-7": "Distance",
    "field-8": "Quantité",
    "field-9": "A/R",
    "field-10": "Motif",
    "field-11": "Statut",
    "field-12": "Aucune mission",
    "field-13": "Liaison"
  },
  "en": {
    "delete-msg-1": "Delete",
    "delete-msg-2": "Are you sure you want to delete the trip",
    "field-1": "Validity",
    "field-2": "Valid",
    "field-3": "Invalid",
    "field-4": "Departure",
    "field-5": "Destination",
    "field-6": "Mode",
    "field-7": "Distance",
    "field-8": "Quantity",
    "field-9": "RT",
    "field-10": "Purpose",
    "field-11": "Position",
    "field-12": "No business trip",
    "field-13": "Section"
  }
}
</i18n>

<template>
  <b-table
    :data="travels"
    :striped="true"
    :narrowed="true"
    :hoverable="true"
    :sort-icon="'angle-up'"
    paginated
    per-page="20"
    default-sort="isValid"
  >
    <b-table-column :custom-sort="sortValid" field="isValid" sortable :label="$t('field-1')" centered v-slot="props">
      <b-tag rounded v-if="props.row.isValid()" type="is-success">{{ $t('field-2') }}</b-tag>
      <b-tag rounded v-else type="is-danger">{{ $t('field-3') }}</b-tag>
    </b-table-column>
    <b-table-column :custom-sort="sortDepartureCity" :label="$t('field-4')" sortable centered v-slot="props">
      <span v-if="props.row.isFromDatabase()">-</span>
      <span v-else>{{ props.row.getDepartureCity() }} ({{ props.row.getDepartureCountry() }})</span>
    </b-table-column>
    <b-table-column :custom-sort="sortDestinationCity" :label="$t('field-5')" sortable centered v-slot="props">
      <span v-if="props.row.isFromDatabase()">-</span>
      <span v-else>{{ props.row.getDestinationCity() }} ({{ props.row.getDestinationCountry() }})</span>
    </b-table-column>
    <b-table-column :custom-sort="sortTransportation" :label="$t('field-6')" sortable centered v-slot="props">
      <div style="white-space:nowrap">
        <b-icon
          v-for="(transportation,index) in props.row.sections.map(obj => obj.transportation)"
          :key="index"
          :pack="modePack(transportation)"
          :icon="modeIcon(transportation)"
        ></b-icon>
      </div>
    </b-table-column>
    <b-table-column field="sections" sortable :label="$t('field-13')" numeric v-slot="props">
      {{ props.row.sections.length }}
    </b-table-column>
    <b-table-column :custom-sort="sortDistance" sortable :label="$t('field-7')" numeric v-slot="props">
      <span v-if="props.row.getDistance() !== null">{{ Math.round(props.row.getDistance()) | splitNumber }} km</span>
      <span v-else>-</span>
    </b-table-column>
    <b-table-column field="amount" sortable :label="$t('field-8')" numeric v-slot="props">
      <span v-if="props.row.amount">
        {{ props.row.amount }}
      </span>
      <span v-else>
        -
      </span>
    </b-table-column>
    <b-table-column :custom-sort="sortRoundTrip" field="isRoundTrip" sortable :label="$t('field-9')" centered v-slot="props">
      <b-icon v-if="props.row.isRoundTrip()" icon="exchange"></b-icon>
      <b-icon v-else icon="long-arrow-right"></b-icon>
    </b-table-column>
    <b-table-column
      field="purpose" sortable :label="$t('field-10')" centered v-slot="props"
    >
      <span v-if="props.row.purpose && props.row.purpose !== 'unknown'">
        {{ $t(props.row.purpose) }}
      </span>
      <span v-else>
        -
      </span>
    </b-table-column>
    <b-table-column
      field="status" :label="$t('field-11')" sortable centered v-slot="props"
    >
      <span v-if="props.row.status && props.row.status !== 'unknown'">
        {{ $t(props.row.status) }}
      </span>
      <span v-else>
        -
      </span>
    </b-table-column>
    <b-table-column v-slot="props">
      <div
        v-if="!props.row.isFromDatabase()"
        class="panel-block"
      >
        <b-tooltip
          :label="$t('edit')"
          type="is-black"
        >
          <b-button
            size="is-small"
            icon-left="pencil"
            @click="edit(props.row)"
          />
        </b-tooltip>
        <b-tooltip
          :label="$t('delete')"
          type="is-black"
        >
          <b-button
            size="is-small"
            icon-left="trash"
            @click="del(props.row)"
          />
        </b-tooltip>
      </div>
    </b-table-column>
    <section slot="empty" class="section">
      <div class="content has-text-grey has-text-centered">
        <p>
          <i class="sui sui-ban" style="font-size: 64px;"></i>
        </p>
        <p>{{ $t('field-12') }}</p>
      </div>
    </section>
  </b-table>
</template>

<script>
import Travel from '@/models/carbon/Travel.js'

export default {
  name: 'TravelsTable',
  computed: {
    travels: function () {
      return this.$store.getters['travels/items']
    }
  },
  methods: {
    sortBool (a, b, isAsc) {
      if (isAsc) {
        return Number(a) - Number(b)
      } else {
        return Number(b) - Number(a)
      }
    },
    sortStr (a, b, isAsc) {
      if (isAsc) {
        return a.localeCompare(b)
      } else {
        return b.localeCompare(a)
      }
    },
    sortValid (a, b, isAsc) {
      return this.sortBool(a.isValid(), b.isValid(), isAsc)
    },
    sortDepartureCity (a, b, isAsc) {
      return this.sortStr(a.getDepartureCity(), b.getDepartureCity(), isAsc)
    },
    sortDestinationCity (a, b, isAsc) {
      return this.sortStr(a.getDestinationCity(), b.getDestinationCity(), isAsc)
    },
    sortDistance (a, b, isAsc) {
      if (isAsc) {
        return a.getDistance() - b.getDistance()
      } else {
        return b.getDistance() - a.getDistance()
      }
    },
    sortRoundTrip (a, b, isAsc) {
      return this.sortBool(a.isRoundTrip(), b.isRoundTrip(), isAsc)
    },
    sortTransportation (a, b, isAsc) {
      return this.sortStr(a.getMainTransportation(), b.getMainTransportation(), isAsc)
    },
    edit: function (travel) {
      this.$emit('edit', travel)
    },
    del: function (travel) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('delete-msg-1'),
        message: self.$t('delete-msg-2') + ' <strong>' + travel.names.join(',') + '</strong> ?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch('travels/delete', travel)
          self.$store.commit('travels/ISMODIFIED', true)
        }
      })
    },
    modeIcon: function (mode) {
      return Travel.getIcon(mode)
    },
    modePack: function (mode) {
      return Travel.getIconPack(mode)
    }
  }
}
</script>

<style lang="css">
tr.is-warning {
  background: #fff1f1 !important;
  color: rgba(0, 0, 0, 0.7) !important;
}
.table td {
  vertical-align: middle !important;
}
</style>
